---
layout: layouts/test.njk
class: 1AKIFT
group: Extra
subject: POS
date: 2021-12-09
points: [2, 2, 8, 5, 5]
grading: "Grading: <11: 5, 11-13: 4, 14-16: 3, 17-19: 2, 20-22: 1"
---

<ol>
  <li>
    {% YesNoTable 4 %}
      {% yes_no_question 'In Python, functions, modules, classes and loops
        create scope.', 'no' %}
      {% yes_no_question 'Programs written in C tend to run faster than
        programs written in Python.', 'yes' %}
      {# {% yes_no_question 'Compiler and interpreter are synonyms for the
        same thing.', 'no' %} #}
      {% yes_no_question 'Any <code>for</code> loop can be re-written as
        <code>while</code> loop.', 'yes' %}
      {# {% yes_no_question 'Programs written in C tend to consume less
        electricity than programs written in Python.', 'yes' %} #}
      {% yes_no_question 'C is still one of the most commonly used programming
        languages.', 'yes' %}
    {% endYesNoTable %}
  </li>

  <li>Each of the following multiple choice questions will be awarded with 1 point if all correct statements are checked and all incorrect statements are not checked.
    <ol>
      <li>{% mcQuestion %}
        Mark all code snippets that are valid Python 3.8

        {% mcChoice true %}
{% highlight "python" %}
def function(arg):
    pass
{% endhighlight %}
        {% endmcChoice %}

        {% mcChoice false %}
{% highlight "python" %}
function sum(arg):
    pass
{% endhighlight %}
        {% endmcChoice %}

        {% mcChoice true %}
{% highlight "python" %}
sum = lambda a, b: a + b
{% endhighlight %}
        {% endmcChoice %}

        {% mcChoice false %}
{% highlight "python" %}
dev sum(a=0, b=0):
    return a + b
{% endhighlight %}
        {% endmcChoice %}
        {% endmcQuestion %}
      </li>

      <li>{% mcQuestion %}
        Mark all correct statements

        {% mcChoice true %}
            <code>f'value is {varname}'</code> produces the same output as
            <br /><code>'value is {}'.format(varname)</code>
        {% endmcChoice %}

        {% mcChoice true %}
            <code>print(f'value is {varname}')</code> produces the same output as
            <br /><code>print('value is', varname)</code>
        {% endmcChoice %}

        {% mcChoice false %}
            <code>print(f'value is {3.1752:.2f}')</code> produces the same output as
            <br /><code>print('value is', 3.1752)</code>
        {% endmcChoice %}

        {% mcChoice true %}
            <code>f'{s} {t}'</code> evaluates to the same as
            <br /><code>str(s) + ' ' + str(t)</code>
        {% endmcChoice %}
        {% endmcQuestion %}
      </li>
    </ol>
  </li>
  <li>What is the output of the following code snippets? Write exactly what the
    output of each snippet is if the snippet is the sole content of a Python
    file. If the output is an error message, it is enough to write “ERROR”.
    If there is no output, write "-".
    <ol>
      <li>
{% highlight "python" %}
if __name__ == "__main__":
    import sys
    print(sys.exit(0))
{% endhighlight %}
{% answer %}
-
{% endanswer %}
      </li>

      <li>
{% highlight "python" %}
def decode(text):
    return encode(text)
print(decode('apt-build moo'))
{% endhighlight %}
{% answer %}
ERROR
{% endanswer %}
      </li>

      <li>
{% highlight "python" %}
def grmpfzotz():
    print('Hooray')
{% endhighlight %}
{% answer %}
-
{% endanswer %}
      </li>

      <li>
{% highlight "python" %}
s = "Everyone wants to become a great programmer."
print(s[:3], s[-1])
{% endhighlight %}
{% answer %}
Eve .
{% endanswer %}
      </li>
    </ol>
  </li>

  <li>Write a function <code>sum_to(num)</code> that takes an integer
    <code>num &gt;= 0</code> as sole
    argument. The function should return the sum of all positive integers
    <code>&lt;= num</code>. In the function, assert that the input is
    &ge; 0 by using <code>assert</code>.<br />
    Grading: 1 point for correct function signature, 1 point for proper
    docstring, 1 for correct assertion, 2 for returning the correct result.
{% answer %}
{% highlight "python" %}
def sum_to(num):
    """
    Sum all numbers from 0 up to a given integer.

    Assert that no negative numbers are entered.
    """
    assert num >= 0, "argument must be >= 0"
    return int(num / 2.0 * (num + 1))
{% endhighlight %}
{% endanswer %}
  </li>

  <li>Write a function <code>sumproduct(first iterable, second iterable)</code>
    in Python that takes two sequences of numbers with equal length and returns
    the sum of the product of the numbers.<br />
    [e.g. <code>sumproduct((1, 3, 4), (9, 2, 3)) ⇒ 1*9 + 3*2 + 4*3 = 27</code>;
     <code>sumproduct([3, 5], [2, 4]) ⇒ 26]</code>.
    Add a proper docstring to receive full points.<br />
    Grading: 1 point for correct function signature, 1 point for proper
    docstring, 1 point for a doctest, 2 for returning the correct result.
{% answer %}
{% highlight "python" %}
def sumproduct(first, second):
    """
    Return the sum of the products of `zip(first, second)`.

    >>> sumproduct((1, 3, 4), (9, 2, 3))
    27
    """
    sum = 0
    for i, j in zip(first, second):
        sum += i * j
    return sum
{% endhighlight %}
{% endanswer %}
  </li>
</ol>
